Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
danhyks

[Yêu Cầu] Code Lấy Tọa Độ 2 Góc Trong Block Khung Tên

Các bài được khuyến nghị

danhyks    0

Hi all.

 

Mình đang muốn lấy tọa độ 2 góc trong khung tên dùng để viết lisp in bản vẽ trong layout. Bạn nào có biết code lấy tọa độ trong block thì hướng dẫn mình với nhé.

 

Thank all.

 

Capture2f85a.png

 

http://www.cadviet.com/upfiles/7/110167_khungten.dwg

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
gia_bach    1.442

Bạn tìm hiểu hàm : vla-GetBoundingBox, trên diễn đàn có nhiếu người sử dụng rồi.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
danhyks    0

Bạn tìm hiểu hàm : vla-GetBoundingBox, trên diễn đàn có nhiếu người sử dụng rồi.

Thank gia_bach nhé. Mình đã làm được tuy nhiên trong model có nhiều bản vẽ nên mình muốn sắp xếp theo thứ tự từ trái sang phải,     từ trên xuống dưới thì dùng hàm nào vậy bạn.

Nếu mình sử dụng hàm chọn tất cả các block "KhungTen" sau đó mình cho chạy hàm Repeat nhưng lại không sắp theo thứ tự được.

Bạn vui lòng xem đoạn code này giúp mình nhé.

 

223334444555.png

;-----In pdf ben model-----------------

;^^^^^^^^^^Dinh nghia lay gia tri 2 goc cua block ^^^^^^^^^^^^
(defun mma (entnm)
  (vl-load-com)  
(vla-getboundingbox entnm 'minpoint 'maxpoint)
(setq mp1 (vlax-safearray->list minpoint)
      mp2 (vlax-safearray->list maxpoint)
)
  )


(defun c:pm ()
  (setq ob (ssget ())
	obj (ssname ob 0)
	fn (vl-filename-base (getvar "dwgname"))  ;;;;get file name
	)

  (setq ob (ssget (command "selectsimilar" obj ""))
	n (sslength ob)
	j 1
	i 0
	)
  (repeat n
    (setq objvl (vlax-ename->vla-object (ssname ob i))
	  nu (itoa j)
	  sn (strcat fn "-" nu)
	  )
 (mma objvl)

   (command "-plot" "y" "Model" "DWG to PDF.pc3" "ISO full bleed A1 (594.00 x 841.00 MM)" "m" "l" "n" "w" mp1 mp2 "fit" "center" "" "monochrome.ctb"
	    "y" "" sn "" "" "" "y")
    (setq  i (1+ i)
	  j (1+ j)
	   )
    )
    
  )

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Doan Van Ha    2.680

Dùng 1 hàm sort thôi. Đây là 1 vídụ:

 

(vl-sort lst '(lambda (p1 p2) (if (equal (car p1) (car p2) 1E-3) (> (cadr p1) (cadr p2)) (< (car p1) (car p2)))))

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
danhyks    0

 

Dùng 1 hàm sort thôi. Đây là 1 vídụ:

(vl-sort lst '(lambda (p1 p2) (if (equal (car p1) (car p2) 1E-3) (> (cadr p1) (cadr p2)) (< (car p1) (car p2)))))

Em vẫn không hiểu lắm về hàm này, anh Hà giải thích sơ cho em nhé.

 

Theo như công thức thì mình phải lập danh sách các tọa độ 2 điểm của từng block "KhungTen", sau đó công thức sẽ so sánh tọa độ X và tọa độ Y để lập 1 danh sách "LST". Như vậy sau đó mình làm thế nào để thực hiện lệnh IN với công thức "-Plot" vậy anh Hà.

 

Sẵn tiện anh giải thích tí về hàm lambda nhé, em đọc mà không hiểu gì về hàm lambda tuy nhiên rất nhiều người sử dụng.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Doan Van Ha    2.680

Em vẫn không hiểu lắm về hàm này, anh Hà giải thích sơ cho em nhé.

 

Theo như công thức thì mình phải lập danh sách các tọa độ 2 điểm của từng block "KhungTen", sau đó công thức sẽ so sánh tọa độ X và tọa độ Y để lập 1 danh sách "LST". Như vậy sau đó mình làm thế nào để thực hiện lệnh IN với công thức "-Plot" vậy anh Hà.

 

Sẵn tiện anh giải thích tí về hàm lambda nhé, em đọc mà không hiểu gì về hàm lambda tuy nhiên rất nhiều người sử dụng.

1). Hàm trên sort 1 list các points theo hoành độ. Nếu hoành độ bằng nhau thì sort theo cao độ. Tức là sort từ trái qua phải và từ trên xuống dưới.

2). Khâu "IN" tôi kém vì lâu nay không in.

3). Hàm lamda là 1 hàm như các hàm khác thôi, nhưng nó là hàm vô danh, dùng xong chả lưu lại trong ký ức.

 

 

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×